﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.ComponentModel;

namespace Converter
{
    /// <summary>
    /// Abstract Class that implements the Kill function
    /// 
    /// Why do you need this feature? Because OpenOffice conversion and Word aren't
    /// so reliable. So sometime you could need to Kill the previous instance of the launched process
    /// 
    /// It's not so smart but it works :-)
    /// </summary>
    internal abstract class AbstractConverter:IConverter
    {

        /// <summary>
        /// Kill the processes stored in the array "processnames"
        /// </summary>
        /// <param name="processNames"></param>
        public void Kill(string[] processNames)
        {
            foreach (string s in processNames)
            {
                Process[] p = Process.GetProcessesByName(s);

                foreach (Process pone in p)
                {
                    try
                    {
                        pone.Kill();
                    }
                    catch (Win32Exception)
                    {
                        // do nothing
                    }
                }
            }

        }

        #region abstract methods

        abstract public void CloseConverter();
        abstract public void OpenConverter(bool visible);
        abstract public string ConvDoc(string fileInput, string fileOutput);

        #endregion
    }
}
