﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Converter
{
    /// <summary>
    /// Interface for all the converter you want to implement
    /// </summary>
    internal interface IConverter
    {
        /// <summary>
        /// Close the converter
        /// </summary>
        void CloseConverter();

        /// <summary>
        /// Open the converter
        /// </summary>
        /// <param name="visible"></param>
        void OpenConverter(bool visible);

        /// <summary>
        /// Convert the document
        /// </summary>
        /// <param name="fileInput"></param>
        /// <param name="fileOutput"></param>
        /// <returns></returns>
        string ConvDoc(string fileInput, string fileOutput);

        /// <summary>
        /// Kill the process that implements the conversion logic
        /// </summary>
        /// <param name="processNames"></param>
        void Kill(string[] processNames);
    }
}
